#ifndef DEVICE_H
#define DEVICE_H
/*
    Copyright (C) 2010  Thomas Schrøder

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    LICENSE.txt file for license details.
*/

#include <iostream>

class Device
{
public:

  virtual ~Device();
  static Device& GetDevice();
  void Init(int argc, char* argv[]);
  static const std::string GetDeviceName();
  static const std::string GetDeviceReport();
  unsigned GetMaximumGridDimensionX();
  unsigned GetComputeCapability();
protected:
  Device() {}
private:
  Device(const Device& d);
  Device& operator=(const Device& d);
  std::string Report();
};

#endif
